package com.vendor.platform.ui.update;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.core.IToolManager;
import com.vendor.platform.core.PlatformCoreActivator;
import com.vendor.platform.core.ToolDescriptor;
import com.vendor.platform.ui.internal.EncryptZipUtil;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Platform;
import org.eclipse.equinox.p2.metadata.IInstallableUnit;

public class UpdateFileChecker implements Runnable {
  private static final String DIR_UPDATES = "updates/";
  
  private static final String UPDATE_EXT = ".upd";
  
  private static final String UPDATE_ZIP = ".zip";
  
  public static final com.vendor.platform.ui.update.UpdateFileChecker INSTANCE = new com.vendor.platform.ui.update.UpdateFileChecker();
  
  HashMap<String, ToolDescriptor> updateFileList = new HashMap<>();
  
  protected boolean isOK = false;
  
  public boolean isOK() {
    return this.isOK;
  }
  
  public HashMap<String, ToolDescriptor> getUpdateFileList() {
    return this.updateFileList;
  }
  
  public void run() {
    File dirUpdates = new File(Platform.getInstallLocation().getURL().getFile() + "updates/");
    if (!dirUpdates.exists()) {
      this.isOK = true;
      return;
    } 
    IToolManager toolManager = PlatformCoreActivator.getDefault().getToolManager();
    File[] files = dirUpdates.listFiles();
    for (File file : files) {
      File unzip = null;
      try {
        if (file.isDirectory() || !file.getCanonicalPath().endsWith(".upd"))
          continue; 
        unzip = new File(file.getCanonicalPath() + ".zip");
      } catch (IOException exce) {
        exce.printStackTrace();
      } 
      if (unzip != null) {
        EncryptZipUtil.decryptZip(file, unzip);
        if (file.delete())
          if (unzip.exists()) {
            ToolDescriptor tool = null;
            try {
              IInstallableUnit unit = toolManager.findToolUnit(unzip
                  .getCanonicalPath(), (IProgressMonitor)new NullProgressMonitor());
              if (unit != null)
                tool = new ToolDescriptor(unit); 
            } catch (Exception e) {}
            try {
              this.updateFileList.put(unzip.getCanonicalPath(), tool);
            } catch (IOException e) {
              e.printStackTrace();
            } 
          }  
      } 
      continue;
    } 
    this.isOK = true;
  }
}
